Description: I'm thinking the [[Using ChiliProject]] page or maybe a *Help* landing page.  Thoughts?

Associated revisions
2011-02-24 11:51 pm - Eric Davis
[#101] Change the help link to point to the version's wiki page

History
2011-01-22 04:47 pm - Muntek Singh
My Proposal [[Help|is this page: Help]]

From IRC:

  10:25:05  Khalsa: guys
 10:25:07  Khalsa: for #101
 10:25:14  Khalsa: what do you think about something like  https://www.chiliproject.org/projects/chiliproject/wiki/Help
 10:33:43  thegcat: Khalsa: reordered it a little bit
 10:35:38  Khalsa: what do you think of having that for #101 :)
 10:36:11 * meineerde loves it
 10:37:03  Khalsa: we might setup a special route or something so the link is chiliproject.org/Help
 10:37:15  Khalsa: as that will be linked from every cp install :)
 10:37:43  Khalsa: and that way in the future, we can just change the special route if we want to redirect the  traffic elsewhere
 10:37:44  meineerde: Khalsa: then I would vote to include a version identifier
 10:38:16  meineerde: and have a comon prefix for those redirection links
 10:38:49  meineerde: and in the long term, I'd love to have a basic documentation bundled with an install  package.
 10:38:53  thegcat: ACK for version, help for 2.0 will confuse users that haven't updated yet
 10:38:58  meineerde: could be generated from the wiki on release date
 10:39:17  Khalsa: yeah then we can archive etc

2011-02-01 10:49 pm - Felix Schäfer
- Status set to Open

2011-02-10 11:54 pm - Eric Davis
- Assignee set to Eric Davis

- Category set to Documentation

I'll start on this

2011-02-20 05:49 pm - Felix Schäfer
The changes in #129 would change the link to @http://www.chiliproject.org/guide@, I'd be OK with that.
2011-02-20 08:23 pm - Muntek Singh
I'd prefer @http://www.chilirpoject.org/help@ myself

2011-02-21 10:42 am - Holger Just
I'd prefer @http://www.chiliproject.org/help/v#{Redmine::VERSION.to_s}@

That way, we can later forward people to the correct documentation version (if and when we start to have something like that). And it would be 
backwards compatible.

2011-02-21 11:20 pm - Eric Davis
I was planning on switching it to @/help@ once I have the plugin for chiliproject.org ready.

Holger: that would be nice but we would have to hack the routes on here for each version or  use a glob route.

2011-02-21 11:25 pm - Holger Just
Eric Davis wrote:
> Holger: that would be nice but we would have to hack the routes on here for each version or  use a glob route.

We could just strip it for now in Apache. Once we have documentation versioning, we can include the tag there. But I'm sure it would be a pain in the 
ass to introduce it later and having to solve the issue of incompatible documentation with confused people in the wild. We could just switch a 
RewriteRule or quickly update some versioned docs without having to solve the problem of too few information.

It doesn't hurt now and makes adaption in the future soo much easier.

2011-02-22 01:06 am - Eric Davis
I'll see if I can find a quick solution using a plugin. Involving Apache will could make things more difficult to test.

2011-02-23 12:29 am - Eric Davis
Holger:

Just found a hidden route that isn't connected to anything. Might try using it.

<pre><code class="ruby">
  map.connect 'help/:ctrl/:page', :controller => 'help'
</code></pre>

https://www.chiliproject.org/projects/chiliproject/repository/revisions/master/entry/config/routes.rb#L15

2011-02-23 12:32 am - Eric Davis
Also found a whole bunch of help documentation and a full help controller around commit:1adf56664d95ba624b81c7cc57603f7f8b5a99c1.

2011-02-23 01:29 am - Eric Davis
I've added some code to our plugin to support @/help@ and @/help/v1.1.0@ redirects. I'll need to finish up the links on the client side next.

What it will do is send @/help@ to a wiki page called "Help" for this project. Requests to @/help/foo@ would go to the wiki page called "Help foo" (after 
removing periods, wiki pages can't have periods). I'm going to use @/help/v1.1.0@ @/help/v2.0.0@ so we will need pages called "Help v110" and 
"Help v200".

h2. Plugin Code (can be checked out from the production server)

<pre><code class="ruby">
# config/routes.rb
ActionController::Routing::Routes.draw do |map|
  map.help 'help/*id', :controller => 'help_redirects', :action => 'show', :project_id => 'chiliproject'
end

# app/controllers/help_redirects_controller.rb
class HelpRedirectsController < ApplicationController
  def show
    project = Project.find_by_identifier(params[:project_id])
    # v1.0.0 => "Help v100"
    # nil => "Help"
    title = if params[:id].present?
              "Help #{params[:id].first}"
            else
              'Help'
            end
    
    if project && project.wiki && help_page = project.wiki.find_page(Wiki.titleize(title))
      redirect_to :controller => 'wiki', :action => 'show', :id => help_page.title, :project_id => 'chiliproject'
    else
      redirect_to :controller => 'wiki', :action => 'show', :id => 'Help', :project_id => 'chiliproject'
    end
    
  end
end

# test
require 'test_helper'

class HelpRedirectTest < ActionController::IntegrationTest
  def setup
    # Bunch of stuff to get all of the records setup
  end
    
  should "redirect /help to a specific wiki page" do
    visit('/help')
    assert_response :success
    assert find('#content .wiki')
    assert has_content?('Welcome to the help')
  end

  should "redirect /help/v1.0.0 to a specific wiki page for v1.0.0" do
    @version_help_page = @wiki.pages.build(:title => 'Help_v100') # Strips .s
    @version_help_page.content = WikiContent.new(:page => @version_help_page, :text => 'Welcome to the help for v1.0.0')
    assert @version_help_page.save
    
    visit('/help/v1.0.0')

    assert_response :success
    assert find('#content .wiki')
    assert has_content?('Welcome to the help for v1.0.0')
  end
end
</code></pre>

2011-02-24 11:08 pm - Eric Davis
- Status changed from Open to Closed

This is done as of commit:69cfe74. Once we update the chiliproject.org server we can hook up the wiki pages.

2020-10-25 4/4


